class NavAdder expands Mutator config(NavAdder);

var bool bInit;
var() config string NoPatchLevel[1024];

native(1718) final function bool AddToPackageMap( optional string PkgName);
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly);

event PreBeginPlay()
{
	local String CLLevelName0, LevelName0, LevelName, LevelName1;
	local Int I, J, k;
	local Class<Actor> Module, Module1;

	if (!bInit)
	{
		bInit = True;
		log ("> Navigation Core Loaded. NavAdder Update 2.",'NavAdder');
		LevelName = String(Outer.Name);
		log ("Scanning NoPatch list...",'NavAdder');
		for ( k = 0; k < 1024; k++ )
		{
			if ( NoPatchLevel[k] != "" )
			{
				if ( LevelName ~= NoPatchLevel[k] )
				{
					log ("Found map"@NoPatchLevel[k]@"as exception from being patched. See config if this is wrong...",'NavAdder');
					GoTo EndOfPatch;
				}
			}
		}
		log ("List Checked. Did not find current map on the list. Looking for patch files...",'NavAdder');
		log ("Map's name is:"@LevelName,'NavAdder');
		LevelName0 = Caps("SS_NVAD"$LevelName)$".PathsMapper";
		log ("Personal seeking strategy: Looking for a class called >"@LevelName0,'NavAdder');
		Module = Class<Actor>( DynamicLoadObject(LevelName0, class'Class',True) );
		if ( Module == None )
		{
			log("Did not find any module or module is unavailable. Seeking alternate old methods...",'NavAdder');
			I = Len(LevelName)-3;
			log ("Testing Map's name length with:"@I@"characters.",'NavAdder');
			LevelName = Caps(Right(LevelName,I))$".PathsMapper";
			log ("Looking for a class called >"@LevelName,'NavAdder');
			Module = Class<Actor>( DynamicLoadObject(LevelName, class'Class',True) );
		}
		if ( Module == None )
		{
			log ("Long Name Scan :: Did not find a module for this Level. Trying old method...",'NavAdder');
			LevelName = String(Outer.Name);
			I = Len(LevelName)-3;
			if ( I > 12 )
			{
				I = 12;
				log ("Cutting Name...",'NavAdder');
				LevelName = Caps(Right(LevelName,I))$".PathsMapper";
				log ("Searching an old module class called >"@LevelName,'NavAdder');
				Module = Class<Actor>( DynamicLoadObject(LevelName, class'Class',True) );
				if ( Module == None )
				{
					log ("No old patch module has been found",'NavAdder');
				}
				else
				{
					log ("Found an old module, attempt loading... "$Module,'NavAdder');
					Spawn(Module);
					if ( Module != None )
						log ("An Old Module has been started...",'NavAdder');
					else
						log ("Bork... Old Module failed to spawn in this Level...",'NavAdder');
				}
			}
			else
			{
				log ("Server-Side scan package by using old method is not available, map-name string is already small...",'NavAdder');
			}
		}
		else
		{
			log ("Found module, attempt loading... "$Module,'NavAdder');
			Spawn(Module);
			if ( Module != None )
				log ("Module has been started...",'NavAdder');
			else
				log ("Bork... Module failed to spawn in this Level...",'NavAdder');
		}
		I = 0;
		LevelName = "";
		LevelName0 = "";
		Module = None;

		log ("Searching server-client stuff if available...",'NavAdder');
			LevelName1 = String(Outer.Name);
		log ("Map's name is:"@LevelName1,'NavAdder');
		CLLevelName0 = Caps("SCL_NVAD"$LevelName1)$".StuffTweaker";
		log ("Personal seeking strategy: Looking for a common server-client class called >"@CLLevelName0,'NavAdder');
		Module1 = Class<Actor>( DynamicLoadObject(CLLevelName0, class'Class',True) );
		if ( Module1 == None )
		{
			log("Did not find any common module or module is unavailable. Seeking alternate old methods...",'NavAdder');
			J = Len(LevelName1)-3;
			log ("Map's name length is:"@J@"characters.",'NavAdder');
			LevelName1 = Caps(Right(LevelName1,J))$".StuffTweaker";
			LevelName1 = "P_"$LevelName1;
			log ("Target class is called >"@LevelName1,'NavAdder');
			Module1 = Class<Actor>( DynamicLoadObject(LevelName1, class'Class',True) );
		}
		if ( Module1 == None )
		{
			log ("Long Name Scan :: Did not find a common module for this Level. Trying old method...",'NavAdder');
			LevelName1 = String(Outer.Name);
			J = Len(LevelName1)-3;
			if ( J > 12 )
			{
				J = 12;
				log ("Cutting Name...",'NavAdder');
				LevelName1 = Caps(Right(LevelName1,J))$".StuffTweaker";
				LevelName1 = "P_"$LevelName1;
				log ("Old module and Target class is called >"@LevelName1,'NavAdder');
				Module1 = Class<Actor>( DynamicLoadObject(LevelName1, class'Class',True) );
				if ( Module1 == None )
				{
					log ("Old common modules unavailable...",'NavAdder');
				}
				else
				{
					log ("Found an old tweaking module, attempt loading... "$Module1,'NavAdder');
					Spawn(Module1);
					if ( Module1 != None )
					{
						if ( Level.NetMode == NM_ListenServer || Level.NetMode == NM_DedicatedServer )
							AddToPackageMap( string(Module1.Outer.Name) );
						log ("Old Module has been started...",'NavAdder');
					}
					else
					{
						log("BORK - UNABLE To Load old Module !",'NavAdder');
					}
				}
			}
			else
			{
				log("Old method scan for common stuff is not available, map-name string is already small...",'NavAdder');
			}
		}
		else
		{
			log ("Found a tweaking module, attempt loading... "$Module1,'NavAdder');
			Spawn(Module1);
			if ( Module1 != None )
			{
				if ( Level.NetMode == NM_ListenServer || Level.NetMode == NM_DedicatedServer )
					AddToPackageMap( string(Module1.Outer.Name) );
				log ("Module has been started...",'NavAdder');
			}
			else
				log ("Bork... Module failed to spawn in this Level...",'NavAdder');
		}
		J = 0;
		LevelName1 = "";
		CLLevelName0 = "";
		Module1 = None;
		GoTo Done;
EndOfPatch:
	log ("NoPatch list checked... None patch will be done...",'NavAdder');
Done:
	}
}

defaultproperties
{
}
